package com.magnatune.eyecreate.companionformagnatune.login;

import android.content.Context;
import android.content.SharedPreferences;

import com.magnatune.eyecreate.companionformagnatune.MagnatuneCompainionApplication;
import com.magnatune.eyecreate.companionformagnatune.R;

public class MagnatuneAccountManager {

    private static final String UNSECURE_STORAGE = "unsecurestorage";
    private static final String SECURE_STORAGE = "securestorage";
    private static final String SP_KEY_USERNAME = "username";
    private static final String SP_KEY_PASSWORD = "password";
    private static final String SP_KEY_LOGGED_IN = "loggedin";

    public static String getMagnatuneName() {
        ObscuredSharedPreferences securedPrefs = ObscuredSharedPreferences.getPrefs(MagnatuneCompainionApplication.getApplication(), SECURE_STORAGE, Context.MODE_PRIVATE);
        String username = securedPrefs.getString(SP_KEY_USERNAME,MagnatuneCompainionApplication.getApplication().getString(R.string.anon_user));
        if(MagnatuneCompainionApplication.getApplication().getString(R.string.anon_user).equals(username) && isLoggedIn()) {
            username = MagnatuneCompainionApplication.getApplication().getString(R.string.invalid);
        }
        return username;
    }

    public static String getMagnatunePassword() {
        ObscuredSharedPreferences securedPrefs = ObscuredSharedPreferences.getPrefs(MagnatuneCompainionApplication.getApplication(), SECURE_STORAGE, Context.MODE_PRIVATE);
        String password = securedPrefs.getString(SP_KEY_PASSWORD,"");
        return password;
    }

    public static boolean isLoggedIn() {
        SharedPreferences unsecuredPrefs = MagnatuneCompainionApplication.getApplication().getSharedPreferences(UNSECURE_STORAGE, Context.MODE_PRIVATE);
        return unsecuredPrefs.getBoolean(SP_KEY_LOGGED_IN,false);
    }

    public static void login(String username,String password) {
        //TODO:check for validity here
        ObscuredSharedPreferences securedPrefs = ObscuredSharedPreferences.getPrefs(MagnatuneCompainionApplication.getApplication(), SECURE_STORAGE, Context.MODE_PRIVATE);
        SharedPreferences unsecuredPrefs = MagnatuneCompainionApplication.getApplication().getSharedPreferences(UNSECURE_STORAGE, Context.MODE_PRIVATE);
        securedPrefs.edit().putString(SP_KEY_USERNAME,username).apply();
        securedPrefs.edit().putString(SP_KEY_PASSWORD,password).apply();
        unsecuredPrefs.edit().putBoolean(SP_KEY_LOGGED_IN,true).apply();
    }

    public static void logout() {
        ObscuredSharedPreferences securedPrefs = ObscuredSharedPreferences.getPrefs(MagnatuneCompainionApplication.getApplication(), SECURE_STORAGE, Context.MODE_PRIVATE);
        SharedPreferences unsecuredPrefs = MagnatuneCompainionApplication.getApplication().getSharedPreferences(UNSECURE_STORAGE, Context.MODE_PRIVATE);
        securedPrefs.edit().remove(SP_KEY_USERNAME).remove(SP_KEY_PASSWORD).apply();
        unsecuredPrefs.edit().remove(SP_KEY_LOGGED_IN).apply();
    }
}
