package com.magnatune.eyecreate.companionformagnatune.service;

import android.os.Parcel;
import android.os.Parcelable;

import java.util.ArrayList;

public class Playlist implements Parcelable {

    private ArrayList<String> playlistIds;
    private String currentlyPlayingId;
    private int currentPositionMill;

    public Playlist() {
        playlistIds = new ArrayList<>();
    }

    protected Playlist(Parcel in) {
        in.readStringList(getPlaylistIds());
        setCurrentlyPlayingId(in.readString());
        setCurrentPositionMill(in.readInt());
    }

    public static final Creator<Playlist> CREATOR = new Creator<Playlist>() {
        @Override
        public Playlist createFromParcel(Parcel in) {
            return new Playlist(in);
        }

        @Override
        public Playlist[] newArray(int size) {
            return new Playlist[size];
        }
    };

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeStringList(getPlaylistIds());
        parcel.writeString(getCurrentlyPlayingId());
        parcel.writeInt(getCurrentPositionMill());
    }

    public ArrayList<String> getPlaylistIds() {
        return playlistIds;
    }

    public void addToPlaylist(String id) {
        this.playlistIds.add(id);
    }

    public void removeFromPlaylist(int itemPosition) {
        this.playlistIds.remove(itemPosition);
    }

    public void clearPlaylist() {
        this.playlistIds.clear();
    }

    public String getCurrentlyPlayingId() {
        return currentlyPlayingId;
    }

    public void setCurrentlyPlayingId(String currentlyPlayingId) {
        this.currentlyPlayingId = currentlyPlayingId;
    }

    public int getCurrentPositionMill() {
        return currentPositionMill;
    }

    public void setCurrentPositionMill(int currentPositionMill) {
        this.currentPositionMill = currentPositionMill;
    }
}
